<script>
  import Buildingtype from './_design_1_buildingtype.svelte';
  import Buildingtype_perline from './_design_1_buildingtype_perline.svelte';
  import Buildingtype_perlinela from './_design_1_buildingtype_perlinela.svelte';
  import Controls from './_design_1_controls.svelte';
  import { scaleLinear,scaleLog } from 'd3-scale';
  import { extent, max } from "d3-array";
  import { day_width, day_height, yScale, city_chosen, scale_chosen } from "./store.js";
  import { json } from 'd3-fetch';
  import { select } from 'd3-selection';
  import { onMount } from "svelte";




  // Load the data
  let datapoints = []
  onMount(async () => {
    datapoints = await json("/data/hourly_heating_december.json");
  });
  

  //$: console.log(datapoints)
 
  

  let transformed_data = {}
  $: {datapoints.forEach((d)=>{
    if(!(d.city in transformed_data)){
      transformed_data[d.city] = {}
    }

    if(!(d.buildingtype in transformed_data[d.city])){
      transformed_data[d.city][d.buildingtype] = []
    }
    
    if(!(d.day in transformed_data[d.city][d.buildingtype])){
      transformed_data[d.city][d.buildingtype][d.day] = {"values":[], "date":d.day}
     
    }
    if(!(d.hour in transformed_data[d.city][d.buildingtype][d.day])){
      transformed_data[d.city][d.buildingtype][d.day]["values"].push(d.total_heating_energy)

    }
  })

  }
  
  //$: console.log(transformed_data)

   $: $yScale = scaleLinear().domain([0,3800]).range([day_height,0]);

  $: selected_data = function (city, transformed_data){
    let result = transformed_data["Baltimore"];
    if(city == "Baltimore"){
      return result;
    }
    else if (city == "Chicago"){
      result = transformed_data["Chicago"];
      return result;
    }
    else {
      result = transformed_data["Los Angeles"];
      return result;
    }
  }
  

  


</script>

  
 {#if $scale_chosen=="across all building types"}
 <div class="container">
   <div class="row align-items-center justify-center">

  <Buildingtype data = {selected_data($city_chosen, transformed_data)} />
  <Controls data = {datapoints} bind:city={$city_chosen} />
   </div>
  </div>
 {:else if $scale_chosen=="within building type"}
   {#if $city_chosen=="Los Angeles"}
   <div class="container">
     <div class="row align-items-center justify-center">
  
          <Buildingtype_perlinela data = {selected_data($city_chosen, transformed_data)} />
          <Controls data = {datapoints} bind:city={$city_chosen} />
        
     </div>
    </div>
   {:else}
      <div class="container">
         <div class="row align-items-center justify-center">

         <Buildingtype_perline data = {selected_data($city_chosen, transformed_data)} />
         <Controls data = {datapoints} bind:city={$city_chosen} />
      
        </div>
      </div>
   {/if}
  {/if}

 

  


  
   
   
    



